| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ChannelDispatcherInterface Class Reference
Client-side proxies » ChannelDispatcher proxies

`#include <TelepathyQt/ChannelDispatcher>`

Inheritance diagram for Tp::Client::ChannelDispatcherInterface:
[legend]

## Public Slots

QDBusPendingReply< QDBusObjectPath > | CreateChannel (const QDBusObjectPath &account, const QVariantMap &requestedProperties, qlonglong userActionTime, const QString &preferredHandler, int timeout=-1)
QDBusPendingReply< QDBusObjectPath > | EnsureChannel (const QDBusObjectPath &account, const QVariantMap &requestedProperties, qlonglong userActionTime, const QString &preferredHandler, int timeout=-1)
QDBusPendingReply< QDBusObjectPath > | CreateChannelWithHints (const QDBusObjectPath &account, const QVariantMap &requestedProperties, qlonglong userActionTime, const QString &preferredHandler, const QVariantMap &hints, int timeout=-1)
QDBusPendingReply< QDBusObjectPath > | EnsureChannelWithHints (const QDBusObjectPath &account, const QVariantMap &requestedProperties, qlonglong userActionTime, const QString &preferredHandler, const QVariantMap &hints, int timeout=-1)
QDBusPendingReply< Tp::ObjectPathList, Tp::NotDelegatedMap > | DelegateChannels (const Tp::ObjectPathList &channels, qlonglong userActionTime, const QString &preferredHandler, int timeout=-1)
QDBusPendingReply | PresentChannel (const QDBusObjectPath &channel, qlonglong userActionTime, int timeout=-1)

## Public Member Functions

| ChannelDispatcherInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelDispatcherInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelDispatcherInterface (Tp::DBusProxy *proxy)
Tp::PendingVariant * | requestPropertyInterfaces () const
Tp::PendingVariant * | requestPropertySupportsRequestHints () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const
Public Member Functions inherited from QDBusAbstractInterface
virtual | ~QDBusAbstractInterface ()
bool | isValid () const
QDBusConnection | connection () const
QString | service () const
QString | path () const
QString | interface () const
QDBusError | lastError () const
void | setTimeout (int timeout)
int | timeout () const
QDBusMessage | call (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | call (QDBus::CallMode mode, const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | callWithArgumentList (QDBus::CallMode mode, const QString &method, const QList< QVariant > &args)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *returnMethod, const char *errorMethod)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *slot)
QDBusPendingCall | asyncCall (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusPendingCall | asyncCallWithArgumentList (const QString &method, const QList< QVariant > &args)
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()
Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)

## Additional Inherited Members

Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)
Protected Slots inherited from Tp::AbstractInterface
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.ChannelDispatcher".

## Constructor & Destructor Documentation

Tp::Client::ChannelDispatcherInterface::ChannelDispatcherInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelDispatcherInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelDispatcherInterface::ChannelDispatcherInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelDispatcherInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ChannelDispatcherInterface::ChannelDispatcherInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelDispatcherInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## Member Function Documentation

static QLatin1String Tp::Client::ChannelDispatcherInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.ChannelDispatcher", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::ChannelDispatcherInterface::requestPropertyInterfaces | ( |  | ) | const

inline

Asynchronous getter for the remote object property `Interfaces` of type `QStringList`.

A list of the extra interfaces provided by this channel dispatcher.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ChannelDispatcherInterface::requestPropertySupportsRequestHints | ( |  | ) | const

inline

Asynchronous getter for the remote object property `SupportsRequestHints` of type `bool`.

If True, the channel dispatcher is new enough to support CreateChannelWithHints and EnsureChannelWithHints, in addition to the older CreateChannel and EnsureChannel methods, and also new enough to emit SucceededWithChannel before the older Succeeded signal. If False or missing, only the metadata-less variants are supported.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::ChannelDispatcherInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply<QDBusObjectPath> Tp::Client::ChannelDispatcherInterface::CreateChannel | ( | const QDBusObjectPath & | account,
|  | const QVariantMap & | requestedProperties,
|  | qlonglong | userActionTime,
|  | const QString & | preferredHandler,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `CreateChannel` on the remote object.

Equivalent to calling CreateChannelWithHints() with an empty Hints parameter.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  account

      The Account for which the new channel is to be created.

  requestedProperties | A dictionary containing desirable properties. This parameter is used in the same way as the corresponding parameter to CreateChannelWithHints() .
  userActionTime | The time at which user action occurred, or 0 if this channel request is for some reason not involving user action. This parameter is used in the same way as the corresponding parameter to CreateChannelWithHints() .
  preferredHandler | Either the well-known bus name (starting with `org.freedesktop.Telepathy.Client.`) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable. This parameter is used in the same way as the corresponding parameter to CreateChannelWithHints() .
  timeout | The timeout in milliseconds.

Returns

      A ChannelRequest object.

QDBusPendingReply<QDBusObjectPath> Tp::Client::ChannelDispatcherInterface::EnsureChannel | ( | const QDBusObjectPath & | account,
|  | const QVariantMap & | requestedProperties,
|  | qlonglong | userActionTime,
|  | const QString & | preferredHandler,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `EnsureChannel` on the remote object.

Equivalent to calling EnsureChannelWithHints() with an empty Hints parameter.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  account

      The Account for which the new channel is to be created.

  requestedProperties | A dictionary containing desirable properties. This parameter is used in the same way as the corresponding parameter to CreateChannelWithHints() .
  userActionTime | The time at which user action occurred, or 0 if this channel request is for some reason not involving user action. This parameter is used in the same way as the corresponding parameter to CreateChannelWithHints() .
  preferredHandler | Either the well-known bus name (starting with `org.freedesktop.Telepathy.Client.`) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable. The behaviour and rationale are the same as for the corresponding parameter to EnsureChannelWithHints() .
  timeout | The timeout in milliseconds.

Returns

      A ChannelRequest object.

QDBusPendingReply<QDBusObjectPath> Tp::Client::ChannelDispatcherInterface::CreateChannelWithHints | ( | const QDBusObjectPath & | account,
|  | const QVariantMap & | requestedProperties,
|  | qlonglong | userActionTime,
|  | const QString & | preferredHandler,
|  | const QVariantMap & | hints,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `CreateChannelWithHints` on the remote object.

Start a request to create a channel. This initially just creates a ChannelRequestInterface object, which can be used to continue the request and track its success or failure.

The request can take a long time - in the worst case, the channel dispatcher has to ask the account manager to put the account online, the account manager has to ask the operating system to obtain an Internet connection, and the operating system has to ask the user whether to activate an Internet connection using an on-demand mechanism like dialup.

This means that using a single D-Bus method call and response to represent the whole request will tend to lead to that call timing out, which is not the behaviour we want.

If this method is called for an Account that is disabled, invalid or otherwise unusable, no error is signalled until ChannelRequestInterface::Proceed() is called, at which point ChannelRequestInterface::Failed() is emitted with an appropriate error.

This means there's only one code path for errors, apart from InvalidArgument for "that request makes no sense".

It also means that the request will proceed if the account is enabled after calling CreateChannel, but before calling Proceed.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  account

      The Account for which the new channel is to be created.

  requestedProperties

  A dictionary containing desirable properties. This has the same semantics as the corresponding parameter to ConnectionInterfaceRequestsInterface::CreateChannel() .

  Certain properties will not necessarily make sense in this dictionary: for instance, ChannelInterface::TargetHandle can only be given if the requester is able to interact with a ConnectionInterface to the desired account.

  userActionTime | The time at which user action occurred, or 0 if this channel request is for some reason not involving user action. The ChannelRequestInterface::UserActionTime property will be set to this value, and it will eventually be passed as the `User_Action_Time` parameter of ClientHandlerInterface::HandleChannels() .

  preferredHandler

  Either the well-known bus name (starting with `org.freedesktop.Telepathy.Client.`) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable. The channel dispatcher SHOULD dispatch as many as possible of the resulting channels (ideally, all of them) to that handler—irrespective of whether that handler's ClientHandlerInterface::HandlerChannelFilter matches the channel—and SHOULD remember the preferred handler so it can try to dispatch subsequent channels in the same bundle to the same handler.

  This must be the well-known bus name, not the unique name, to ensure that all handlers do indeed have the Client API, and the Client object on the handler can be located easily.

  This is partly so the channel dispatcher can call ClientHandlerInterface::HandleChannels() on it, and partly so the channel dispatcher can recover state if it crashes and is restarted.

  The filter should be disregarded for ease of use of this interface: clients will usually use this argument to request channels be sent to themself, and this should trump the filter not matching. This also allows a client to become the handler for a channel produced by one of its own requests, while not being a candidate to handle other channels of that type.

  If this is a well-known bus name and the handler has the Requests interface, the channel dispatcher SHOULD call ClientInterfaceRequestsInterface::AddRequest() on that Handler after this method has returned.

  This ordering allows a Handler which calls CreateChannel with itself as the preferred handler to associate the call to AddRequest with that call.

  This is copied to the ChannelRequest that is returned, as the ChannelRequestInterface::PreferredHandler property.

  hints

      Additional information about the channel request, which will be
      used as the value for the resulting request&apos;s Hints property.
      See the Hints property&apos;s documentation for rationale.

  timeout | The timeout in milliseconds.

Returns

      A ChannelRequest object.

QDBusPendingReply<QDBusObjectPath> Tp::Client::ChannelDispatcherInterface::EnsureChannelWithHints | ( | const QDBusObjectPath & | account,
|  | const QVariantMap & | requestedProperties,
|  | qlonglong | userActionTime,
|  | const QString & | preferredHandler,
|  | const QVariantMap & | hints,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `EnsureChannelWithHints` on the remote object.

Start a request to ensure that a channel exists, creating it if necessary. This initially just creates a ChannelRequestInterface object, which can be used to continue the request and track its success or failure.

If this method is called for an Account that is disabled, invalid or otherwise unusable, no error is signalled until ChannelRequestInterface::Proceed() is called, at which point ChannelRequestInterface::Failed() is emitted with an appropriate error.

The rationale is as for ChannelDispatcherInterface::CreateChannelWithHints() .

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  account

      The Account for which the new channel is to be created.

  requestedProperties

  A dictionary containing desirable properties. This has the same semantics as the corresponding parameter to ConnectionInterfaceRequestsInterface::EnsureChannel() .

  Certain properties will not necessarily make sense in this dictionary: for instance, ChannelInterface::TargetHandle can only be given if the requester is able to interact with a ConnectionInterface to the desired account.

  userActionTime | The time at which user action occurred, or 0 if this channel request is for some reason not involving user action. This parameter is used in the same way as the corresponding parameter to CreateChannelWithHints() .

  preferredHandler

  Either the well-known bus name (starting with `org.freedesktop.Telepathy.Client.`) of the preferred handler for this channel, or an empty string to indicate that any handler would be acceptable. The behaviour and rationale are the same as for the corresponding parameter to CreateChannelWithHints() , except as noted here.

  If any new channels are created in response to this request, the channel dispatcher SHOULD dispatch as many as possible of the resulting channels (ideally, all of them) to that handler, and SHOULD remember the preferred handler so it can try to dispatch subsequent channels in the same bundle to the same handler. If the requested channel already exists (that is, ConnectionInterfaceRequestsInterface::EnsureChannel() returns `Yours=False`) then the channel dispatcher SHOULD re-dispatch the channel to its existing handler, and MUST NOT dispatch it to this client (unless it is the existing handler); the request is still deemed to have succeeded in this case.

  An address book application, for example, might call ChannelDispatcherInterface::EnsureChannel() to ensure that a text channel with a particular contact is displayed to the user; it does not care whether a new channel was made. An IM client might call ChannelDispatcherInterface::EnsureChannel() in response to the user double-clicking an entry in the contact list, with itself as the `Preferred_Handler`; if the user already has a conversation with that contact in another application, they would expect the existing window to be presented, rather than their double-click leading to an error message. So the request should succeed, even if its `Preferred_Handler` is not used.

  hints

      Additional information about the channel request, which will be
      used as the value for the resulting request&apos;s Hints property.

  timeout | The timeout in milliseconds.

Returns

      A ChannelRequest object.

QDBusPendingReply<Tp::ObjectPathList, Tp::NotDelegatedMap> Tp::Client::ChannelDispatcherInterface::DelegateChannels | ( | const Tp::ObjectPathList & | channels,
|  | qlonglong | userActionTime,
|  | const QString & | preferredHandler,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `DelegateChannels` on the remote object.

Called by a ClientHandlerInterface to redispatch a bunch of channels it is currently handling.

For each Channel in Channels, if another ClientHandlerInterface can be found, ClientHandlerInterface::HandleChannels() will be called on it until a ClientHandlerInterface accepts it.

This method returns once all the Channels have either been accepted or rejected by Handlers.

If this method fails, the original ClientHandlerInterface is still handling the channels.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  channels | The list of channels to redispatch. The caller has to be the current ClientHandlerInterface of all of these channels
  userActionTime | The time at which user action occurred, or 0 if this channels delegation is for some reason not involving user action. This parameter is used in the same way as the corresponding parameter to CreateChannelWithHints() .
  preferredHandler | Either the well-known bus name (starting with `org.freedesktop.Telepathy.Client.`) of the preferred new handler for these channels, or an empty string to indicate that any handler would be acceptable. The behaviour and rationale are the same as for the corresponding parameter to CreateChannelWithHints() .
  timeout | The timeout in milliseconds.

Returns

The list of channels which have been delegated; the caller is no longer handling these channels.

The client should remove these channels from its ClientHandlerInterface::HandledChannels property.

Returns

The list of channels which have NOT been delegated; the caller is still handling these channels.

QDBusPendingReply Tp::Client::ChannelDispatcherInterface::PresentChannel | ( | const QDBusObjectPath & | channel,
|  | qlonglong | userActionTime,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `PresentChannel` on the remote object.

Equivalent of calling ChannelDispatcherInterface::EnsureChannel() with a Requested_Properties which would result in ensuring Channel.

If Channel is handled, its handler will be asked to present it the user (e.g. bring it into the foreground).

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  channel | The channel to present.
  userActionTime | The time at which user action occurred, or 0 if this channel request is for some reason not involving user action. This parameter is used in the same way as the corresponding parameter to EnsureChannelWithHints() .
  timeout | The timeout in milliseconds.

void Tp::Client::ChannelDispatcherInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.